function ThemeList::onWake(%this)
{
	%this.loadingList = true;
	if(!%this.generatedList)
	{
		%index = 1;
		%mask = "Add-Ons/Theme_*/description.txt";
		for(%file = findFirstFile(%mask); %file !$= ""; %file = findNextFile(%mask))
		{
			%path = filePath(%file);
			%name = strReplace(getSubStr(%path, 14, strLen(%path)), "_", " ");
			%this.addFront(%name, %index);
			%index ++;
		}
		%this.addFront("DEFAULT", 0);
		%this.generatedList = true;
	}
	if(Themes.themePath $= "")
		%this.setSelected(0);
	else
	{
		%path = Themes.themePath;
		%themeName = strReplace(getSubStr(%path, 14, strLen(%path)), "_", " ");
		%count = %this.size();
		for(%i = 1; %i < %count; %i ++)
		{
			%item = %this.getTextByID(%i);
			if(%item $= %themeName)
			{
				%this.setSelected(%i);
				break;
			}
		}
	}
	%this.loadingList = false;
}

function ThemeList::onPickTheme(%this, %index)
{
	if(%this.loadingList)
		return;
	%path = %this.getTextByID(%index);
	if(%path $= "Default")
		%path = "";
	else
		%path = "Add-Ons/Theme_" @ strReplace(%path, " ", "_");
	if(%path !$= Themes.themePath)
	{
		$Pref::Themes::CurrentTheme = %path;
		Themes.applyTheme(%path);
	}
}

if(!isObject(ThemeOptions))
{
	new GuiBitmapButtonCtrl(ThemeOptionsButton)
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "203 4";
		extent = "110 18";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		command = "canvas.pushDialog(ThemeOptions);";
		text = "Theme";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		alignTop = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	OptGraphicsPane.getObject(3).add(ThemeOptionsButton);

	new GuiControl(ThemeOptions)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		themeApplying = "0";
		themed = "1";

		new GuiWindowCtrl()
		{
			profile = "BlockWindowProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "160 59";
			extent = "200 100";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			command = "canvas.popDialog(ThemeOptions);";
			accelerator = "escape";
			text = "Theme Options";
			maxLength = "255";
			resizeWidth = "1";
			resizeHeight = "1";
			canMove = "1";
			canClose = "1";
			canMinimize = "1";
			canMaximize = "1";
			minSize = "50 50";
			closeCommand = "canvas.popDialog(ThemeOptions);";
			themeApplying = "0";
			themed = "1";

			new GuiPopUpMenuCtrl(ThemeList)
			{
				profile = "GuiPopUpMenuProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "10 45";
				extent = "180 30";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				command = "ThemeList.onPickTheme(ThemeList.getSelected());";
				clipToParent = "1";
				maxLength = "255";
				maxPopupHeight = "200";
				themeApplying = "0";
				themed = "1";
			};
		};
	};
}